//----------------------------------------------------------------------------//
//                                         888                                //
//                                         888                                //
//                                         888                                //
//                         8888b.  888d888 888  888                           //
//                            `88b 888P'   888 .88P                           //
//                        .d888888 888     888888K                            //
//                        888  888 888     888 `88b                           //
//                        `Y888888 888     888  888                           //
//                                                                            //
//                                                                            //
//  File      : base_scene.mjs                                                //
//  Project   : doom_fire                                                     //
//  Date      : 14 Dec, 21                                                    //
//  License   : GPLv3                                                         //
//  Author    : stdmatt <stdmatt@pixelwizards.io>                             //
//  Copyright : stdmatt - 2021                                                //
//                                                                            //
//  Description :                                                             //
//                                                                            //
//---------------------------------------------------------------------------~//

//----------------------------------------------------------------------------//
// Imports                                                                    //
//----------------------------------------------------------------------------//
//------------------------------------------------------------------------------
import { Utils     } from "./utils.mjs"
import { Log_Utils } from "./log_utils.mjs";

//----------------------------------------------------------------------------//
// Base_Scene                                                                 //
//----------------------------------------------------------------------------//
//------------------------------------------------------------------------------
export class Base_Scene
    extends PIXI.Container
{
    //--------------------------------------------------------------------------
    constructor()
    {
        super();
        Utils.add_luna_unique_object_id(this);
    } // scene

    //--------------------------------------------------------------------------
    on_update(dt)
    {
        // Do nothing...
    }

    //------------------------------------------------------------------------//
    // Scene Events                                                           //
    //------------------------------------------------------------------------//
    //--------------------------------------------------------------------------
    on_load()
    {
        // Do nothing...
        Log_Utils.log_verbose(this.constructor.name, this._luna_object_id);
    }

    //--------------------------------------------------------------------------
    on_unload()
    {
        // Do nothing...
        Log_Utils.log_verbose(this.constructor.name, this._luna_object_id);
    }

    //--------------------------------------------------------------------------
    on_enter()
    {
        // Do nothing...
        Log_Utils.log_verbose(this.constructor.name, this._luna_object_id);
    }

    //--------------------------------------------------------------------------
    on_exit()
    {
        // Do nothing...
        Log_Utils.log_verbose(this.constructor.name, this._luna_object_id);
    }

    //------------------------------------------------------------------------//
    // Window Events                                                          //
    //------------------------------------------------------------------------//
    //--------------------------------------------------------------------------
    on_resize()
    {
        // Do nothing...
        Log_Utils.log_verbose(this.constructor.name, this._luna_object_id);
    }

};
